//+------------------------------------------------------------------+
//|                                          BucCurrencyStrength.mq4 |
//|                                    Copyright  2007, Petr Kouril |
//|                                           http://www.jaktrade.cz |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Petr Kouril"
#property link      "http://www.bucafon.cz"

#define           GLOBAL_PREF             "BucCM_"       // toto musi  stejne jako pouziva slave!!!
#define           GLOBAL_TIMEPREF         "BucCMTime_"   // toto musi  stejne jako pouziva slave!!!

#define           OBJECT_PREF             "BucServer_"   // Zobrazeni hdnot men
#define           CHAR_HEIGHT             7
#define           OBJECT_XDIFF            45

#property indicator_separate_window
#property indicator_minimum  0
#property indicator_maximum  100


#property indicator_buffers 8
#property indicator_color1 Red         // USD
#property indicator_color2 Black       // EUR
#property indicator_color3 Blue        // GBP
#property indicator_color4 DarkGreen   // CHF
#property indicator_color5 Indigo      // CAD
#property indicator_color6 Orange      // AUD
#property indicator_color7 Magenta     // JPY
#property indicator_color8 Lime        // NZD
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1

extern bool       SetGlobalVariable       = false;
//extern string     DataFileName            = "";
extern int        LowHighBarsBack         = 0;             // pokud je to 0, bere se to od 0:00 - klasicky
extern int        LowHighBarsTimeFrame    = PERIOD_H1;
extern int        ShowHistoryBars         = 100;
double            TS_USD, TS_EUR, TS_GBP, TS_CHF, TS_CAD, TS_AUD, TS_JPY, TS_NZD;
double            Lows[29], Highs[29], Multiples[29], Bids[29];

//---- buffers
double            BuffUSD[], BuffEUR[], BuffGBP[], BuffCHF[], BuffCAD[], BuffAUD[], BuffJPY[], BuffNZD[];

int init()
{
	IndicatorBuffers(8);

   SetIndexStyle (0, DRAW_LINE);
   SetIndexBuffer(0, BuffUSD);
   SetIndexLabel (0, "USD");

   SetIndexStyle (1, DRAW_LINE);
   SetIndexBuffer(1, BuffEUR);
   SetIndexLabel (1, "EUR");

   SetIndexStyle (2, DRAW_LINE);
   SetIndexBuffer(2, BuffGBP);
   SetIndexLabel (2, "GBP");

   SetIndexStyle (3, DRAW_LINE);
   SetIndexBuffer(3, BuffCHF);
   SetIndexLabel (3, "CHF");

   SetIndexStyle (4, DRAW_LINE);
   SetIndexBuffer(4, BuffCAD);
   SetIndexLabel (4, "CAD");

   SetIndexStyle (5, DRAW_LINE);
   SetIndexBuffer(5, BuffAUD);
   SetIndexLabel (5, "AUD");

   SetIndexStyle (6, DRAW_LINE);
   SetIndexBuffer(6, BuffJPY);
   SetIndexLabel (6, "JPY");

   SetIndexStyle (7, DRAW_LINE);
   SetIndexBuffer(7, BuffNZD);
   SetIndexLabel (7, "NZD");
   

   IndicatorShortName(GetIndicatorShortName());
   return(0);
}

string GetIndicatorShortName()
{
   return ("BucCMMaster(" + LowHighBarsBack + "," + LowHighBarsTimeFrame + ")");
}

int deinit()
{
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "USD");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "EUR");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "GBP");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "CHF");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "CAD");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "AUD");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "JPY");
   ObjectDelete(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "NZD");
   return(0);
}

int start()
{
  int counted_bars = IndicatorCounted();
	int i, j, limit;
	
	//---- 
	  if(counted_bars < 0) 
	    { 
	      Print("Indicator Error (Counted bars < 0)!"); 
	      return(-1); 
	    }
  //----
	 
	for(i=Bars-counted_bars; i>=0; i--)
  {
   if (i>ShowHistoryBars) i=ShowHistoryBars;
   
   CurrencyMeter(i);   
         
   BuffUSD[i] = TS_USD;
   BuffEUR[i] = TS_EUR;
   BuffGBP[i] = TS_GBP;
   BuffCHF[i] = TS_CHF;
   BuffCAD[i] = TS_CAD;
   BuffAUD[i] = TS_AUD;
   BuffJPY[i] = TS_JPY;
   BuffNZD[i] = TS_NZD;
  }
  
   if (SetGlobalVariable)
   {
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "USD", TS_USD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "EUR", TS_EUR);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "GBP", TS_GBP);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "CHF", TS_CHF);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "CAD", TS_CAD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "AUD", TS_AUD);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "JPY", TS_JPY);
      GlobalVariableSet(GLOBAL_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "NZD", TS_NZD);
      
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Hour",     Hour());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Minute",   Minute());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "Second",   Seconds());
      GlobalVariableSet(GLOBAL_TIMEPREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0) + "DateTime", TimeCurrent());
   }
  
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "USD",  1 + 0 * OBJECT_XDIFF, 1, "USD " + DoubleToStr(TS_USD, 0), indicator_color1);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "EUR",  1 + 1 * OBJECT_XDIFF, 1, "EUR " + DoubleToStr(TS_EUR, 0), indicator_color2);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "GBP",  1 + 2 * OBJECT_XDIFF, 1, "GBP " + DoubleToStr(TS_GBP, 0), indicator_color3);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "CHF",  1 + 3 * OBJECT_XDIFF, 1, "CHF " + DoubleToStr(TS_CHF, 0), indicator_color4);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "CAD",  1 + 4 * OBJECT_XDIFF, 1, "CAD " + DoubleToStr(TS_CAD, 0), indicator_color5);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "AUD",  1 + 5 * OBJECT_XDIFF, 1, "AUD " + DoubleToStr(TS_AUD, 0), indicator_color6);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "JPY",  1 + 6 * OBJECT_XDIFF, 1, "JPY " + DoubleToStr(TS_JPY, 0), indicator_color4);
   ShowTextObject(OBJECT_PREF + DoubleToStr(LowHighBarsBack * LowHighBarsTimeFrame, 0)  + "NZD",  1 + 7 * OBJECT_XDIFF, 1, "NZD " + DoubleToStr(TS_NZD, 0), indicator_color8);
}

void ShowTextObject(string ObjName, int XPos, int YPos, string TextToShow, int TextColor)
{
   if (ObjectFind(ObjName) == -1)
   {
//      ObjectCreate (ObjName, OBJ_LABEL, WindowFind(WindowExpertName()), 0, 0);
      ObjectCreate (ObjName, OBJ_LABEL, WindowFind(GetIndicatorShortName()), 0, 0);
      ObjectSet    (ObjName, OBJPROP_CORNER, 2);
      ObjectSet    (ObjName, OBJPROP_XDISTANCE, XPos);
      ObjectSet    (ObjName, OBJPROP_YDISTANCE, YPos);
   }
   ObjectSetText(ObjName, TextToShow, CHAR_HEIGHT, "Arial Bold", TextColor);
}

double GetBid(int CurIndex, int shift)
{
   if (shift==0)
    return (MarketInfo(GetCurrencyNameByIndex(CurIndex), MODE_BID));
   else
    return (iClose(GetCurrencyNameByIndex(CurIndex), Period(), shift));
}

double GetLow(int CurIndex, int shift)
{
   if (LowHighBarsBack == 0)
      return (iLow(GetCurrencyNameByIndex(CurIndex), 1440, shift/1440));
   else
   {
      double CurLow, CurCandleLow;
      for (int i = 0; i < LowHighBarsBack; i++)
      {
         CurCandleLow = iLow(GetCurrencyNameByIndex(CurIndex), LowHighBarsTimeFrame, (shift/LowHighBarsTimeFrame)+i);   //shift s ohledem na aktualni TF
         if (i == 0)                CurLow = CurCandleLow;
         if (CurCandleLow < CurLow) CurLow = CurCandleLow;
      }
      return (CurLow);
   }
}


double GetHigh(int CurIndex, int shift)
{
   if (LowHighBarsBack == 0)
      return (iHigh(GetCurrencyNameByIndex(CurIndex), 1440, shift/1440));
   else
   {
      double CurHigh, CurCandleHigh;
      for (int i = 0; i < LowHighBarsBack; i++)
      {
         CurCandleHigh = iHigh(GetCurrencyNameByIndex(CurIndex), LowHighBarsTimeFrame, (shift/LowHighBarsTimeFrame)+i);
         if (i == 0)                  CurHigh = CurCandleHigh;
         if (CurCandleHigh > CurHigh) CurHigh = CurCandleHigh;
      }
      return (CurHigh);
   }
}

double GetMultiple(int CurIndex)
{
   double CurPoint = MarketInfo(GetCurrencyNameByIndex(CurIndex), MODE_POINT);
   
   if (CurPoint > 0.000000001)
      return (1 / CurPoint);
   else
      return (10000);
}

string GetCurrencyNameByIndex(int Index)
{
   switch (Index)
   {
   case 1: return  ("EURUSD");
   case 2: return  ("GBPUSD");
   case 3: return  ("AUDUSD");
   case 4: return  ("USDJPY");
   case 5: return  ("USDCHF");
   case 6: return  ("USDCAD");
   case 7: return  ("EURJPY");
   case 8: return  ("EURGBP");
   case 9: return  ("EURCHF");
   case 10: return ("EURAUD");
   case 11: return ("GBPJPY");
   case 12: return ("GBPCHF");
   case 13: return ("EURCAD");
   case 14: return ("CHFJPY");
   case 15: return ("CADJPY");
   case 16: return ("CADCHF");
   case 17: return ("AUDCHF");
   case 18: return ("AUDCAD");
   case 19: return ("AUDJPY");
   case 20: return ("NZDUSD");
   case 21: return ("NZDCAD");
   case 22: return ("NZDCHF");
   case 23: return ("NZDJPY");
   case 24: return ("NZDGBP");
   case 25: return ("EURNZD");
   case 26: return ("GBPCAD");
   case 27: return ("GBPAUD");
   case 28: return ("AUDNZD");
   default: return ("");
   }
}

void FillHighAndLow(int shift)
{
   for (int i = 1; i <= 28; i++)
   {
      Lows[i]      = GetLow(i, shift);
      Highs[i]     = GetHigh(i, shift);
      Multiples[i] = GetMultiple(i);
      Bids[i]      = GetBid(i, shift);
   }
}


void CurrencyMeter(int shift)
{
   FillHighAndLow(shift);
   
   double pip_range[29];
   for (int i = 1; i <= 28; i++)
      pip_range[i]  = (Highs[i] - Lows[i]) * Multiples[i];

   double bid_ratio[29];
   for (i = 0; i <= 28; i++)
   {
      if (pip_range[i] > 0.5)
         bid_ratio[i]  = (Bids[i] - Lows[i]) / pip_range[i]  * Multiples[i] * 100;
      else
         bid_ratio[i] = 50;
   }
   
   double RS13[29];
   double RS15[29];
   for (i = 1; i <= 28; i++)
   {
      RS13[i] = bid_ratio[i];
      RS15[i] = 100 - RS13[i]; //vypocet Relative Strenght (radek v exceli je 15)
   }
   
   TS_USD = NormalizeDouble((RS13[4]+RS13[5]+RS13[6]+RS15[1]+RS15[2]+RS15[3]+RS15[20])/7 ,0);
   TS_EUR = NormalizeDouble((RS13[1]+RS13[7]+RS13[8]+RS13[9]+RS13[10]+RS13[13]+RS13[25])/7 ,0);
   TS_GBP = NormalizeDouble((RS13[2]+RS13[11]+RS13[12]+RS13[26]+RS13[27]+RS15[8])/6 ,0);
   TS_CHF = NormalizeDouble((RS13[14]+RS15[5]+RS15[9]+RS15[12]+RS15[16]+RS15[17]+RS15[22])/7 ,0);
   TS_CAD = NormalizeDouble((RS13[15]+RS13[16]+RS15[6]+RS15[13]+RS15[18]+RS15[21]+RS15[26])/7 ,0);
   TS_AUD = NormalizeDouble((RS13[3]+RS13[17]+RS13[18]+RS13[19]+RS13[28]+RS15[10]+RS15[27])/7 ,0);
   TS_JPY = NormalizeDouble((RS15[4]+RS15[7]+RS15[11]+RS15[14]+RS15[15]+RS15[19]+RS15[23])/7 ,0);
   TS_NZD = NormalizeDouble((RS13[20]+RS13[21]+RS13[22]+RS13[23]+RS15[25]+RS15[28])/6 ,0);

}   

